//+------------------------------------------------------------------+
//|                                            Engulfing Pattern.mq4 |
//|                        Copyright 2020, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2020, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict

double Open1;
double Open2;
double Close1;
double Close2;
double High1;
double High2;
double Low1;
double Low2;
double FastMA;
double SlowMA;

extern int Stop_Loss=100;
extern int Take_Profit=100;
extern double Lot_Size = 0.01;

double TakeProfit= NormalizeDouble(Take_Profit*10*Point,5);
double StopLoss= NormalizeDouble(Stop_Loss*10*Point,5);        
   
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {  
  
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
   Open1 = NormalizeDouble(iOpen(Symbol(), Period(), 0), 5);
   Open2 = NormalizeDouble(iOpen(Symbol(), Period(), 1), 5);
   Close1 = NormalizeDouble(iClose(Symbol(), Period(), 0), 5);
   Close2 = NormalizeDouble(iClose(Symbol(), Period(), 1), 5);
   High1 = NormalizeDouble(iHigh(Symbol(), Period(), 0), 5);
   High2 = NormalizeDouble(iHigh(Symbol(), Period(), 1), 5);
   Low1 = NormalizeDouble(iLow(Symbol(), Period(), 0), 5);
   Low2 = NormalizeDouble(iLow(Symbol(), Period(), 1), 5);
   FastMA = iMA(Symbol(), PERIOD_CURRENT, 50, 0, MODE_EMA, PRICE_CLOSE, 0);
   SlowMA = iMA(Symbol(), PERIOD_CURRENT, 200, 0, MODE_EMA, PRICE_CLOSE, 0);
   
   if ((FastMA > SlowMA) && CheckBullishEngulfing())Long();
   if ((FastMA < SlowMA) && CheckBearishEngulfing()) Short();      
  }
//+------------------------------------------------------------------+
bool CheckBullishEngulfing()
   {
    if (Open1 < Close1 && 
        Open2 > Close2 && 
        (Close1-Open1) > (Open2-Close2)
       )
    return (true);
    else return (false);
   }
   
bool CheckBearishEngulfing()
   {
    if (Open1 > Close1 && 
        Open2 < Close2 && 
        (Open1-Close1) > (Close2-Open2)
       )
    return (true);
    else return (false);
   }
   
void Long() 
   {
    if (OrdersTotal() == 0) 
    {
     int LongTicket = OrderSend (Symbol(), OP_BUYSTOP, Lot_Size, High1, 3, Ask-StopLoss, Ask+TakeProfit, NULL, 123456, TimeCurrent()+PERIOD_CURRENT);
    }
   }
   
void Short() 
   {
    if (OrdersTotal() == 0) 
    {
     int ShortTicket = OrderSend (Symbol(), OP_SELLSTOP, Lot_Size, Low1, 3, Bid-StopLoss, Bid+TakeProfit, NULL, 123456, TimeCurrent()+PERIOD_CURRENT);
    }
   }